#COPYRIGHT 2018 ESRI
#
#TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
#Unpublished material - all rights reserved under the
#Copyright Laws of the United States.
#
#For additional information, contact:
#Environmental Systems Research Institute, Inc.
#Attn: Contracts Dept
#380 New York Street
#Redlands, California, USA 92373
#
#email: contracts@esri.com
"""
Contains creator functions for complex argument objects.

DO NOT EDIT, THIS FILE IS GENERATED BY A SCRIPT!
"""
from . import Envelope as EnvelopeModule
from . import HorizontalFactor as HorizontalFactorModule
from . import VerticalFactor as VerticalFactorModule
from . import Neighborhood as NeighborhoodModule
from . import Radius as RadiusModule
from . import Time as TimeModule
from . import KrigingModel as KrigingModelModule
from . import FuzzyMembership as FuzzyMembershipModule
from . import Remap as RemapModule
from . import TopoInput as TopoInputModule
from . import WOTable as WOTableModule
from . import WSTable as WSTableModule



__all__ = [
  "Envelope",
  "Rectangle",
  "Extent",
  "HfBinary",
  "HfForward",
  "HfLinear",
  "HfInverseLinear",
  "HfTable",
  "VfBinary",
  "VfLinear",
  "VfInverseLinear",
  "VfSymLinear",
  "VfSymInverseLinear",
  "VfCos",
  "VfSec",
  "VfCosSec",
  "VfSecCos",
  "VfTable",
  "NbrAnnulus",
  "NbrCircle",
  "NbrIrregular",
  "NbrRectangle",
  "NbrWedge",
  "NbrWeight",
  "RadiusVariable",
  "RadiusFixed",
  "TimeWithinDay",
  "TimeSpecialDays",
  "TimeMultipleDays",
  "TimeWholeYear",
  "KrigingModelOrdinary",
  "KrigingModelUniversal",
  "FuzzyGaussian",
  "FuzzyLarge",
  "FuzzyLinear",
  "FuzzyMSLarge",
  "FuzzyMSSmall",
  "FuzzyNear",
  "FuzzySmall",
  "RemapRange",
  "RemapValue",
  "TopoPointElevation",
  "TopoContour",
  "TopoStream",
  "TopoSink",
  "TopoBoundary",
  "TopoLake",
  "WOTable",
  "WSTable",
]



def Envelope(
         x_min,
         y_min,
         x_max,
         y_max):
  """Envelope(x_min, y_min, x_max, y_max)

  Returns Envelope argument object.

  Arguments:
  x_min -- Minimum x coordinate
  y_min -- Minimum y coordinate
  x_max -- Maximum x coordinate
  y_max -- Maximum y coordinate
  """
  return EnvelopeModule.Envelope(x_min, y_min, x_max, y_max)

Envelope.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def Rectangle(
         x_min,
         y_min,
         x_max,
         y_max):
  """Rectangle(x_min, y_min, x_max, y_max)

  Returns Envelope argument object.

  Arguments:
  x_min -- Minimum x coordinate
  y_min -- Minimum y coordinate
  x_max -- Maximum x coordinate
  y_max -- Maximum y coordinate
  """
  return EnvelopeModule.Envelope(x_min, y_min, x_max, y_max)

Rectangle.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def Extent(
         x_min,
         y_min,
         x_max,
         y_max):
  """Extent(x_min, y_min, x_max, y_max)

  Returns Envelope argument object.

  Arguments:
  x_min -- Minimum x coordinate
  y_min -- Minimum y coordinate
  x_max -- Maximum x coordinate
  y_max -- Maximum y coordinate
  """
  return EnvelopeModule.Envelope(x_min, y_min, x_max, y_max)

Extent.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def HfBinary(
         zero_factor=None,
         cut_angle=None):
  """HfBinary({zero_factor}, {cut_angle})

  Returns Binary argument object.

  Arguments:
  zero_factor -- Zero factor
  cut_angle -- Cut angle
  """
  return HorizontalFactorModule.Binary(zero_factor, cut_angle)

HfBinary.__esri_toolinfo__ = [
  "Double:::",
  "Double:::"
]



def HfForward(
         zero_factor=None,
         side_value=None):
  """HfForward({zero_factor}, {side_value})

  Returns Forward argument object.

  Arguments:
  zero_factor -- Zero factor
  side_value -- Side value
  """
  return HorizontalFactorModule.Forward(zero_factor, side_value)

HfForward.__esri_toolinfo__ = [
  "Double:::",
  "Double:::"
]



def HfLinear(
         zero_factor=None,
         cut_angle=None,
         slope=None):
  """HfLinear({zero_factor}, {cut_angle}, {slope})

  Returns Linear argument object.

  Arguments:
  zero_factor -- Zero factor
  cut_angle -- Cut angle
  slope -- Slope
  """
  return HorizontalFactorModule.Linear(zero_factor, cut_angle, slope)

HfLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::"
]



def HfInverseLinear(
         zero_factor=None,
         cut_angle=None,
         slope=None):
  """HfInverseLinear({zero_factor}, {cut_angle}, {slope})

  Returns InverseLinear argument object.

  Arguments:
  zero_factor -- Zero factor
  cut_angle -- Cut angle
  slope -- Slope
  """
  return HorizontalFactorModule.InverseLinear(zero_factor, cut_angle, slope)

HfInverseLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::"
]



def HfTable(
         in_table):
  """HfTable(in_table)

  Returns Table argument object.

  Arguments:
  in_table -- Table name
  """
  return HorizontalFactorModule.Table(in_table)

HfTable.__esri_toolinfo__ = [
  "DEFile:::"
]



def VfBinary(
         zero_factor=None,
         low_cut_angle=None,
         high_cut_angle=None):
  """VfBinary({zero_factor}, {low_cut_angle}, {high_cut_angle})

  Returns Binary argument object.

  Arguments:
  zero_factor -- Zero factor
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  """
  return VerticalFactorModule.Binary(zero_factor, low_cut_angle, high_cut_angle)

VfBinary.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfLinear(
         zero_factor=None,
         low_cut_angle=None,
         high_cut_angle=None,
         slope=None):
  """VfLinear({zero_factor}, {low_cut_angle}, {high_cut_angle}, {slope})

  Returns Linear argument object.

  Arguments:
  zero_factor -- Zero factor
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  slope -- Slope
  """
  return VerticalFactorModule.Linear(zero_factor, low_cut_angle, high_cut_angle, slope)

VfLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfInverseLinear(
         zero_factor=None,
         low_cut_angle=None,
         high_cut_angle=None,
         slope=None):
  """VfInverseLinear({zero_factor}, {low_cut_angle}, {high_cut_angle}, {slope})

  Returns InverseLinear argument object.

  Arguments:
  zero_factor -- Zero factor
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  slope -- Slope
  """
  return VerticalFactorModule.InverseLinear(zero_factor, low_cut_angle, high_cut_angle, slope)

VfInverseLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfSymLinear(
         zero_factor=None,
         low_cut_angle=None,
         high_cut_angle=None,
         slope=None):
  """VfSymLinear({zero_factor}, {low_cut_angle}, {high_cut_angle}, {slope})

  Returns SymLinear argument object.

  Arguments:
  zero_factor -- Zero factor
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  slope -- Slope
  """
  return VerticalFactorModule.SymLinear(zero_factor, low_cut_angle, high_cut_angle, slope)

VfSymLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfSymInverseLinear(
         zero_factor=None,
         low_cut_angle=None,
         high_cut_angle=None,
         slope=None):
  """VfSymInverseLinear({zero_factor}, {low_cut_angle}, {high_cut_angle}, {slope})

  Returns SymInverseLinear argument object.

  Arguments:
  zero_factor -- Zero factor
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  slope -- Slope
  """
  return VerticalFactorModule.SymInverseLinear(zero_factor, low_cut_angle, high_cut_angle, slope)

VfSymInverseLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfCos(
         low_cut_angle=None,
         high_cut_angle=None,
         cos_power=None):
  """VfCos({low_cut_angle}, {high_cut_angle}, {cos_power})

  Returns Cos argument object.

  Arguments:
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  cos_power -- Cos power
  """
  return VerticalFactorModule.Cos(low_cut_angle, high_cut_angle, cos_power)

VfCos.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfSec(
         low_cut_angle=None,
         high_cut_angle=None,
         sec_power=None):
  """VfSec({low_cut_angle}, {high_cut_angle}, {sec_power})

  Returns Sec argument object.

  Arguments:
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  sec_power -- Sec power
  """
  return VerticalFactorModule.Sec(low_cut_angle, high_cut_angle, sec_power)

VfSec.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfCosSec(
         low_cut_angle=None,
         high_cut_angle=None,
         cos_power=None,
         sec_power=None):
  """VfCosSec({low_cut_angle}, {high_cut_angle}, {cos_power}, {sec_power})

  Returns CosSec argument object.

  Arguments:
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  cos_power -- Cos power
  sec_power -- Sec power
  """
  return VerticalFactorModule.CosSec(low_cut_angle, high_cut_angle, cos_power, sec_power)

VfCosSec.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfSecCos(
         low_cut_angle=None,
         high_cut_angle=None,
         sec_power=None,
         cos_power=None):
  """VfSecCos({low_cut_angle}, {high_cut_angle}, {sec_power}, {cos_power})

  Returns SecCos argument object.

  Arguments:
  low_cut_angle -- Low cut angle
  high_cut_angle -- High cut angle
  sec_power -- Sec power
  cos_power -- Cos power
  """
  return VerticalFactorModule.SecCos(low_cut_angle, high_cut_angle, sec_power, cos_power)

VfSecCos.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def VfTable(
         in_table):
  """VfTable(in_table)

  Returns Table argument object.

  Arguments:
  in_table -- Table name
  """
  return VerticalFactorModule.Table(in_table)

VfTable.__esri_toolinfo__ = [
  "DEFile:::"
]



def NbrAnnulus(
         inner_radius=None,
         outer_radius=None,
         units=None):
  """NbrAnnulus({inner_radius}, {outer_radius}, {CELL|MAP})

  Returns Annulus argument object.

  Arguments:
  inner_radius -- Inner radius
  outer_radius -- Outer radius
  units -- Units
  """
  return NeighborhoodModule.Annulus(inner_radius, outer_radius, units)

NbrAnnulus.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "String::CELL|MAP:"
]



def NbrCircle(
         radius=None,
         units=None):
  """NbrCircle({radius}, {CELL|MAP})

  Returns Circle argument object.

  Arguments:
  radius -- Radius
  units -- Units
  """
  return NeighborhoodModule.Circle(radius, units)

NbrCircle.__esri_toolinfo__ = [
  "Double:::",
  "String::CELL|MAP:"
]



def NbrIrregular(
         in_kernel_file):
  """NbrIrregular(in_kernel_file)

  Returns Irregular argument object.

  Arguments:
  in_kernel_file -- Kernel file
  """
  return NeighborhoodModule.Irregular(in_kernel_file)

NbrIrregular.__esri_toolinfo__ = [
  "DEFile:::"
]



def NbrRectangle(
         width=None,
         height=None,
         units=None):
  """NbrRectangle({width}, {height}, {CELL|MAP})

  Returns Rectangle argument object.

  Arguments:
  width -- Width
  height -- Height
  units -- Units
  """
  return NeighborhoodModule.Rectangle(width, height, units)

NbrRectangle.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "String::CELL|MAP:"
]



def NbrWedge(
         start_angle=None,
         end_angle=None,
         radius=None,
         units=None):
  """NbrWedge({start_angle}, {end_angle}, {radius}, {CELL|MAP})

  Returns Wedge argument object.

  Arguments:
  start_angle -- Start angle
  end_angle -- End angle
  radius -- Radius
  units -- Units
  """
  return NeighborhoodModule.Wedge(start_angle, end_angle, radius, units)

NbrWedge.__esri_toolinfo__ = [
  "Double:::",
  "Double:::",
  "Double:::",
  "String::CELL|MAP:"
]



def NbrWeight(
         in_kernel_file):
  """NbrWeight(in_kernel_file)

  Returns Weight argument object.

  Arguments:
  in_kernel_file -- Kernel file
  """
  return NeighborhoodModule.Weight(in_kernel_file)

NbrWeight.__esri_toolinfo__ = [
  "DEFile:::"
]



def RadiusVariable(
         number_of_points=None,
         max_distance=None):
  """RadiusVariable({number_of_points}, {max_distance})

  Returns Variable argument object.

  Arguments:
  number_of_points -- Number of points
  max_distance -- Maximum distance

  Notes:
  SearchRadius
  - VariableSearchRadius
  - FixedSearchRadius
  """
  return RadiusModule.Variable(number_of_points, max_distance)

RadiusVariable.__esri_toolinfo__ = [
  "Long:::",
  "Double:::"
]



def RadiusFixed(
         distance=None,
         min_number_of_points=None):
  """RadiusFixed({distance}, {min_number_of_points})

  Returns Fixed argument object.

  Arguments:
  distance -- Distance
  min_number_of_points -- Minimum number of points

  Notes:
  SearchRadius
  - VariableSearchRadius
  - FixedSearchRadius
  """
  return RadiusModule.Fixed(distance, min_number_of_points)

RadiusFixed.__esri_toolinfo__ = [
  "Double:::",
  "Long:::"
]



def TimeWithinDay(
         day=None,
         start_time=None,
         end_time=None):
  """TimeWithinDay({day}, {start_time}, {end_time})

  Returns WithinDay argument object.

  Arguments:
  day -- Julian day
  start_time -- Start time
  end_time -- End time

  Notes:
  Confirm the types of the arguments. As they are now, you are not expected
  to provide floating point values.
  """
  return TimeModule.WithinDay(day, start_time, end_time)

TimeWithinDay.__esri_toolinfo__ = [
  "Long:::",
  "Double:::",
  "Double:::"
]



def TimeSpecialDays(
         ):
  """TimeSpecialDays()

  Returns SpecialDays argument object.

  Notes:
  Confirm the types of the arguments. As they are now, you are not expected
  to provide floating point values.
  """
  return TimeModule.SpecialDays()

TimeSpecialDays.__esri_toolinfo__ = [
]



def TimeMultipleDays(
         year=None,
         start_day=None,
         end_day=None):
  """TimeMultipleDays({year}, {start_day}, {end_day})

  Returns MultipleDays argument object.

  Arguments:
  year -- Year
  start_day -- Start day
  end_day -- End day

  Notes:
  Confirm the types of the arguments. As they are now, you are not expected
  to provide floating point values.
  """
  return TimeModule.MultipleDays(year, start_day, end_day)

TimeMultipleDays.__esri_toolinfo__ = [
  "Long:::",
  "Long:::",
  "Long:::"
]



def TimeWholeYear(
         year=None):
  """TimeWholeYear({year})

  Returns WholeYear argument object.

  Arguments:
  year -- Year

  Notes:
  Confirm the types of the arguments. As they are now, you are not expected
  to provide floating point values.
  """
  return TimeModule.WholeYear(year)

TimeWholeYear.__esri_toolinfo__ = [
  "Long:::"
]



def KrigingModelOrdinary(
         semivariogram_type,
         lag_size=None,
         major_range=None,
         partial_sill=None,
         nugget=None):
  """KrigingModelOrdinary(SPHERICAL|CIRCULAR|EXPONENTIAL|GAUSSIAN|LINEAR, {lag_size}, {major_range}, {partial_sill}, {nugget})

  Returns Ordinary argument object.

  Arguments:
  semivariogram_type -- Semivariogram type
  lag_size -- Lag size
  major_range -- Major range
  partial_sill -- Major range
  nugget -- Nugget
  """
  return KrigingModelModule.Ordinary(semivariogram_type, lag_size, major_range, partial_sill, nugget)

KrigingModelOrdinary.__esri_toolinfo__ = [
  "String::SPHERICAL|CIRCULAR|EXPONENTIAL|GAUSSIAN|LINEAR:",
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def KrigingModelUniversal(
         semivariogram_type,
         lag_size=None,
         major_range=None,
         partial_sill=None,
         nugget=None):
  """KrigingModelUniversal(LINEARDRIFT|QUADRATICDRIFT, {lag_size}, {major_range}, {partial_sill}, {nugget})

  Returns Universal argument object.

  Arguments:
  semivariogram_type -- Semivariogram type
  lag_size -- Lag size
  major_range -- Major range
  partial_sill -- Major range
  nugget -- Nugget
  """
  return KrigingModelModule.Universal(semivariogram_type, lag_size, major_range, partial_sill, nugget)

KrigingModelUniversal.__esri_toolinfo__ = [
  "String::LINEARDRIFT|QUADRATICDRIFT:",
  "Double:::",
  "Double:::",
  "Double:::",
  "Double:::"
]



def FuzzyGaussian(
         midpoint=None,
         spread=None):
  """FuzzyGaussian({midpoint}, {spread})

  Returns Gaussian argument object.

  Arguments:
  midpoint -- Midpoint
  spread -- Spread

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.Gaussian(midpoint, spread)

FuzzyGaussian.__esri_toolinfo__ = [
  "Point:::",
  "Double:::"
]



def FuzzyLarge(
         midpoint=None,
         spread=None):
  """FuzzyLarge({midpoint}, {spread})

  Returns Large argument object.

  Arguments:
  midpoint -- Midpoint
  spread -- Spread

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.Large(midpoint, spread)

FuzzyLarge.__esri_toolinfo__ = [
  "Point:::",
  "Double:::"
]



def FuzzyLinear(
         min=None,
         max=None):
  """FuzzyLinear({min}, {max})

  Returns Linear argument object.

  Arguments:
  min -- Minimum
  max -- Maximum

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.Linear(min, max)

FuzzyLinear.__esri_toolinfo__ = [
  "Double:::",
  "Double:::"
]



def FuzzyMSLarge(
         mean_multiplier=None,
         std_multiplier=None):
  """FuzzyMSLarge({mean_multiplier}, {std_multiplier})

  Returns MSLarge argument object.

  Arguments:
  mean_multiplier -- Mean multiplier
  std_multiplier -- Standard multiplier

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.MSLarge(mean_multiplier, std_multiplier)

FuzzyMSLarge.__esri_toolinfo__ = [
  "Double:::",
  "Double:::"
]



def FuzzyMSSmall(
         mean_multiplier=None,
         std_multiplier=None):
  """FuzzyMSSmall({mean_multiplier}, {std_multiplier})

  Returns MSSmall argument object.

  Arguments:
  mean_multiplier -- Mean multiplier
  std_multiplier -- Standard multiplier

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.MSSmall(mean_multiplier, std_multiplier)

FuzzyMSSmall.__esri_toolinfo__ = [
  "Double:::",
  "Double:::"
]



def FuzzyNear(
         midpoint=None,
         spread=None):
  """FuzzyNear({midpoint}, {spread})

  Returns Near argument object.

  Arguments:
  midpoint -- Midpoint
  spread -- Spread

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.Near(midpoint, spread)

FuzzyNear.__esri_toolinfo__ = [
  "Point:::",
  "Double:::"
]



def FuzzySmall(
         midpoint=None,
         spread=None):
  """FuzzySmall({midpoint}, {spread})

  Returns Small argument object.

  Arguments:
  midpoint -- Midpoint
  spread -- Spread

  Notes:
  There is no tool that makes use of this argument type yet.
  """
  return FuzzyMembershipModule.Small(midpoint, spread)

FuzzySmall.__esri_toolinfo__ = [
  "Point:::",
  "Double:::"
]



def RemapRange(
         table):
  """RemapRange([[start_value, end_value, new_value],...])

  Returns RemapRange argument object.

  Arguments:
  start_value -- Double
  end_value -- Double
  new_value -- Long
  """
  return RemapModule.RemapRange(table)

RemapRange.__esri_toolinfo__ = [
  "::::",
]



def RemapValue(
         table):
  """RemapValue([[old_value, new_value],...])

  Returns RemapValue argument object.

  Arguments:
  old_value -- Double | String
  new_value -- Long
  """
  return RemapModule.RemapValue(table)

RemapValue.__esri_toolinfo__ = [
  "::::",
]



def WOTable(
         table,
         list_):

  """WOTable([[in_raster, influence, field, remap],...], [from, to, by])

  Returns WOTable argument object.

  Arguments:
  in_raster -- Raster
  influence -- Double
  field -- Field
  remap -- Remap
  from -- Long
  to -- Long
  by -- Long
  """
  return WOTableModule.WOTable(table, list_)

WOTable.__esri_toolinfo__ = [
  "::::",
]



def WSTable(
         table):
  """WSTable([[in_raster, field, weight],...])

  Returns WSTable argument object.

  Arguments:
  in_raster -- Raster
  field -- Field
  weight -- Double
  """
  return WSTableModule.WSTable(table)

WSTable.__esri_toolinfo__ = [
  "::::",
]



def TopoPointElevation(
         table):
  """TopoPointElevation([[in_feature, {field}],...])

  Returns TopoPointElevation argument object.

  Arguments:
  in_feature -- Composite geodataset
  field -- Field
  """
  return TopoInputModule.TopoInputNestedList("POINTELEVATION", table)

TopoPointElevation.__esri_toolinfo__ = [
  "::::",
]



def TopoContour(
         table):
  """TopoContour([[in_feature, {field}],...])

  Returns TopoContour argument object.

  Arguments:
  in_feature -- Composite geodataset
  field -- Field
  """
  return TopoInputModule.TopoInputNestedList("CONTOUR", table)

TopoContour.__esri_toolinfo__ = [
  "::::",
]



def TopoStream(
         table):
  """TopoStream([in_feature,...])

  Returns TopoStream argument object.

  Arguments:
  in_feature -- Composite geodataset
  """
  return TopoInputModule.TopoInputList("STREAM", table)

TopoStream.__esri_toolinfo__ = [
  "::::",
]



def TopoSink(
         table):
  """TopoSink([[in_feature, {field}],...])

  Returns TopoSink argument object.

  Arguments:
  in_feature -- Composite geodataset
  field -- Field
  """
  return TopoInputModule.TopoInputNestedList("SINK", table)

TopoSink.__esri_toolinfo__ = [
  "::::",
]



def TopoBoundary(
         table):
  """TopoBoundary([in_feature,...])

  Returns TopoBoundary argument object.

  Arguments:
  in_feature -- Composite geodataset
  """
  return TopoInputModule.TopoInputList("BOUNDARY", table)

TopoBoundary.__esri_toolinfo__ = [
  "::::",
]



def TopoLake(
         table):
  """TopoLake([in_feature,...])

  Returns TopoLake argument object.

  Arguments:
  in_feature -- Composite geodataset
  """
  return TopoInputModule.TopoInputList("LAKE", table)

TopoLake.__esri_toolinfo__ = [
  "::::",
]

